var Fis00100_ApuracaoDeImposto_Service = function(Fis00100_ApuracaoDeImposto_Repository) {

    this.vdImpostoRelac = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.vdImpostoRelac(row);
    };

    /*
     * Na apuração do Simples Nacional somente podem realizar alterações
     * empresas que pertençam ao regime do Simples Nacional (cdsitucrt != '3')
     * Nas apurações do regime normal, empresas com regime Simples Nacional
     * somente poderão realizar alterações se estiver marcado o parâmetro no
     * imposto que permite apurar na tela do regime normal, mesmo sendo
     * empresa do simples
     */
    this.bloqueiaMapaRegime = function(idtipoapura, cdsitucrt, idapuimpgersn) {
        if ((idtipoapura == 'S') && (cdsitucrt == '3')) {
            return true;
        }
        else if ((idtipoapura != 'S') && (cdsitucrt != '3') && (idapuimpgersn == 'N')) {
            return true;
        }
        else {
            return false;
        }
    };

    this.buscaPrxDataIniECodigoMapa = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.buscaPrxDataIniECodigoMapa(row);
    };

    this.saveMapa = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.saveMapa(row);
    };

    this.saveArrecadacaoContribuicoes = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.saveArrecadacaoContribuicoes(row);
    };

    this.checkUltimoMapa = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.checkUltimoMapa(row);
    };
    
    this.validaImpostoApurac = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.validaImpostoApurac(row);
    };

    this.checkValidSequencialDetalhamento = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.checkValidSequencialDetalhamento(row);
    };

    this.apurarMapa = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.apurarMapa(row);
    };

    this.desbloquearMapa = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.desbloquearMapa(row);
    };

    this.bloquearMapa = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.bloquearMapa(row);
    };

    this.deleteMapa = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.deleteMapa(row);
    };

    this.getNextSequencialAjusteContribuicoes = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.getNextSequencialAjusteContribuicoes(row);
    };
    
    this.saveAjusteContribuicoes = function(row) {
        return Fis00100_ApuracaoDeImposto_Repository.saveAjusteContribuicoes(row);
    };

    /*
     * Função para o cálculo do valor do detalhamento de Simples Nacional
     * conforme widget passada.
     */
    this.calculaValorTotalDetalhamento = function(row, nomeWidget) {
        switch(nomeWidget) {
            case 'widgetFatuMensalTributadoSt':
                row.VRIMPOSTOST = (((parseFloat(row.VRBCFATUST) + parseFloat(row.VRCOMPBCST)) - parseFloat(row.VRDEDUZBCST)) * (parseFloat(row.VRALIQST) /100));
                break;

            case 'widgetFatuMensalNaoTributadoSt':
                row.VRIMPOSTOSEMST = (((parseFloat(row.VRBCFATUSEMST) + parseFloat(row.VRCOMPBCSEMST)) - parseFloat(row.VRDEDUZBCSEMST)) * (parseFloat(row.VRALIQFAIXA) /100));
                break;

            case 'widgetFatuMensalIsentoIcms':
                row.VRIMPOISENTO = (((parseFloat(row.VRBCFATUISEN) + parseFloat(row.VRCOMPBCISENTO)) - parseFloat(row.VRDEDUZBCISENTO)) * (parseFloat(row.VRALIQISENTO) /100));
                break;

            case 'widgetFatuExportacao':
                row.VRIMPOSTOEXP = (((parseFloat(row.VRBCFATUEXP) + parseFloat(row.VRCOMPBCEXP)) - parseFloat(row.VRDEDUZBCEXP)) * (parseFloat(row.VRALIQEXP) /100));
                break;

            case 'widgetFatuMensalRetido':
                row.VRIMPOSTORET = ((parseFloat(row.VRBCFATURET) * (parseFloat(row.VRALIQRET) /100)) + parseFloat(row.VRRETIDONPROV)) ;
                break;

            case 'widgetMajoracao':
                row.VRIMPOSTOEXCED = ((parseFloat(row.VRALIQMAJORADA)/100) * parseFloat(row.VRPARCELAEXCED));
                break;
        }
        row.VRIMPOSTOREC = (row.VRIMPOSTOST + row.VRIMPOSTOSEMST + row.VRIMPOISENTO + row.VRIMPOSTOEXP + row.VRIMPOSTOEXCED) - row.VRIMPOSTORET;
    };

};

Configuration(function(ContextRegister) {
     ContextRegister.register('Fis00100_ApuracaoDeImposto_Service', Fis00100_ApuracaoDeImposto_Service);
});
